# MovieSorter

## Overview
MovieSorter is a user-friendly application designed to organize your movie collection efficiently. It supports two languages (English/Persian) and offers both GUI and console interfaces. Whether you prefer a visual interface or command-line operations, MovieSorter makes the sorting and organizing process intuitive and straightforward.

![Program UI](https://github.com/Ahmadrezadl/MovieSorter/blob/master/screenshots/sc2.png)
![Result](https://github.com/Ahmadrezadl/MovieSorter/blob/master/screenshots/sc.jpg)

## Features
- **Multilingual Support:** Use MovieSorter in English or Persian, catering to a diverse user base.
- **Flexible Interfaces:** Choose between a graphical user interface (GUI) or a console-based interaction, according to your preference or use case.
- **Automated Sorting:** Automatically sort your movies into structured directories based on various metadata, such as movie name, year, season, and episode.
- **Customizable Settings:** Tailor the sorting logic and directory structure to your needs through easy-to-configure settings.
## Installation and Usage

### How to Install:
To install MovieSorter, you need to have Python installed on your system. If you have Python set up, you can install MovieSorter using pip. Open your terminal (Command Prompt, PowerShell, or similar on Windows; Terminal on macOS or Linux) and run the following command:

```bash
pip install MovieSorter
```

This command downloads the MovieSorter package and installs it on your system.

### How to Run:

#### Using GUI:
MovieSorter provides a graphical user interface (GUI) for ease of use. To launch the GUI, simply enter the following command in your terminal:

```bash
MovieSorterGUI
```

After executing this command, the graphical interface should appear, allowing you to interact with the application visually.

#### Using Command Line:
If you prefer using the command line or are working in an environment where a GUI is not available, MovieSorter also supports command-line operations. To see the available options and how to use them, run:

```bash
MovieSorter --help
```

This command will display help information, including a list of command-line arguments and options that you can use with MovieSorter.
## Contributing
Contributions to MovieSorter are welcome! Feel free to fork the repository, make your improvements, and submit a pull request. 


## License
[MIT](https://opensource.org/licenses/MIT)